import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class Boundary
{
	String boundaryType;
	float simulationScale; 

	public Boundary(String bt, float s)
	{
		boundaryType = bt;
		simulationScale = 10f / s;
	}
	
	public String getBoundaryType()
	{
		return boundaryType;
	}
	
	public void setSimulationSize(float s)
	{
		simulationScale = 10f / s;
	}
	
	public float j3dSize(float f)
	{
		return f * simulationScale;
	}
	
	public float[] j3dSize(float f[])
	{
		float[] temp = new float[f.length];
		for (int i=0; i<f.length; i++)
		{
			 temp[i] = f[i] * simulationScale;
		}
		return temp;
	}
	
	public void drawBox(Group group)
	{
		if (!boundaryType.equals(""))
		{
			drawBoundingBox(group);
		}
	}
	
	public void drawBoundingBox(Group group)
	{
		Cylinder c;
		Transform3D tran;
		TransformGroup g;
		double ninetydegrees = 90.0 * java.lang.Math.PI / 180.0;
		float rad = 0.07f;
	
		// Create the bounding box
	
		g = new TransformGroup();
		tran = new Transform3D();
		//tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(5f, 0f, 5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		//tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(5f, 0f, -5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		//tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(-5f, 0f, 5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		//tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(-5f, 0f, -5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(0f, 5f, 5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(0f, -5f, 5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(0f, 5f, -5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotZ(ninetydegrees);
		tran.setTranslation(new Vector3f(0f, -5f, -5f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotX(ninetydegrees);
		tran.setTranslation(new Vector3f(5f, 5f, 0f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotX(ninetydegrees);
		tran.setTranslation(new Vector3f(-5f, 5f, 0f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotX(ninetydegrees);
		tran.setTranslation(new Vector3f(5f, -5f, 0f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.rotX(ninetydegrees);
		tran.setTranslation(new Vector3f(-5f, -5f, 0f));
		c = new Cylinder(rad, 10f);
		g.setTransform(tran);
		g.addChild(c);
		group.addChild(g);
		
		// Create spheres for the corners
		Sphere s;
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(5f, 5f, 5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(5f, 5f, -5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(5f, -5f, 5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(5f, -5f, -5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(-5f, 5f, 5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(-5f, 5f, -5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(-5f, -5f, 5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
		
		g = new TransformGroup();
		tran = new Transform3D();
		tran.setTranslation(new Vector3f(-5f, -5f, -5f));
		s = new Sphere(rad);
		g.setTransform(tran);
		g.addChild(s);
		group.addChild(g);
	}
	
	public void enforce(float[] position)
	{
		float limit = 5f / simulationScale; 
		
		if (boundaryType.equals("tessellated"))
		{
			for (int i=0; i<position.length; i++)
			{
				while (position[i] > limit)
				{
					position[i] -= 2f*limit;
				}
				while (position[i] <= -limit)
				{
					position[i] += 2f*limit;
				}		
			}
		}
	}
	
	public float[] vectorBetween(float[] start, float[] end)
	{
		int numEntries;
		if (start.length<end.length)
		{
			numEntries = start.length;
		}
		else 
		{
			numEntries = end.length;
		}
		
		float[] vect = new float[numEntries];
		
		for (int i=0; i<numEntries; i++)
		{
			vect[i] = end[i] - start[i];
		}
		
		if (boundaryType.equals("tessellated"))
		{
			enforce(vect);
		}
		
		return vect;
	}
	
	public float dist(float start, float end)
	{
		float[] s = new float[1];
		float[] e = new float[1];
		s[0] = start;
		e[0] = end;
		float[] d = vectorBetween(s, e);
		return d[0];
	}
}