import javax.swing.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import CoordinateLayout.*;

public class BoundaryPanel extends JPanel
{
	SimulationGenerator simGen;
	
	public BoundaryPanel(SimulationGenerator sgen)
	{
		super();
		
		simGen = sgen;
		
		setLayout(new CoordinateLayout(new Dimension(8,3),4,4));
		
		add(new JLabel("Boundary size :"), new Coordinate(0,0,8,1));
		BoundaryTextField btf = new BoundaryTextField(simGen);
		add(btf, new Coordinate(0,1,3,2));
		BoundaryUnitMenu boundUM = new BoundaryUnitMenu(simGen);
		add(boundUM, new Coordinate(3,1,8,2));
		add(new BoundaryApplyButton(simGen, btf, boundUM), new Coordinate(5,2,8,3));
	}
}

class BoundaryTextField extends JTextField implements KeyListener
{
	SimulationGenerator simGen;
	float val;
	
	public BoundaryTextField(SimulationGenerator sgen)
	{
		super(6);
		setText("500");
		simGen = sgen;
		val = 500f;
		
		setHorizontalAlignment(JTextField.RIGHT);
		addKeyListener(this);
	}
	
	public void keyPressed(KeyEvent ke)
	{}
	
	public void keyTyped(KeyEvent ke)
	{}
	
	public void keyReleased(KeyEvent ke)
	{
		try 
		{
			val = (float) (Float.parseFloat(getText()));
		}
		catch (NumberFormatException e)
		{}
	}
	
	public float getVal()
	{
		return val;
	}
}

// boundary application button
class BoundaryApplyButton extends JButton implements ActionListener
{
	SimulationGenerator simGen;
	BoundaryTextField boundTextField;
	BoundaryUnitMenu boundaryUnitMenu;
	
	public BoundaryApplyButton(SimulationGenerator sg, BoundaryTextField btf, 
							   BoundaryUnitMenu boundUM)
	{
		super("Apply");
		addActionListener(this);
		simGen = sg;
		boundTextField = btf;
		boundaryUnitMenu = boundUM;
	}
	
	public void actionPerformed(ActionEvent ae)
	{
		simGen.setBoundVal(boundTextField.getVal() * boundaryUnitMenu.getUnit());
	}
}

class BoundaryUnitMenu extends JComboBox implements ItemListener
{
	SimulationGenerator simulationGenerator;
	JLabel simElapseUnit;
	float boundaryUnit;
	
	public BoundaryUnitMenu(SimulationGenerator sg)
	{
		super();
		simulationGenerator = sg;
		
		addItem("Metres");
		addItem("Millimetres");
		addItem("Micrometres");
		addItem("Nanometres");
		addItem("Picometres");
		addItem("Femtometres");
		
		setEditable(false);
		
		setSelectedIndex(3);
		boundaryUnit = (float) Math.pow(10.0, -9.0); 
		
		addItemListener(this);
	}
	
	public float getUnit()
	{
		return boundaryUnit;
	}

	public void itemStateChanged(ItemEvent ie)
	{
		String s = (String) ie.getItem();
		
		if (s.equals("Metres")) { boundaryUnit = 1f;  }
		if (s.equals("Millimetres")) 
			{ boundaryUnit = (float) Math.pow(10.0, -3.0);  }
		if (s.equals("Micrometres")) 
			{ boundaryUnit = (float) Math.pow(10.0, -6.0);  }
		if (s.equals("Nanometres")) 
			{ boundaryUnit = (float) Math.pow(10.0, -9.0);  }
		if (s.equals("Picometres")) 
			{ boundaryUnit = (float) Math.pow(10.0, -12.0);  }
		if (s.equals("Femtometres")) 
			{ boundaryUnit = (float) Math.pow(10.0, -15.0);  }
	}
}
