import java.util.*;

public class ConditionTemplate
{
	String parameter;
	String operation;
	int[] particles;
	float[] values;
	Boundary boundary;
	
	public ConditionTemplate(String param, String op, int[] parts, 
							 float[] vals, Boundary b)
	{
		parameter = param;
		operation = op;
		particles = parts;
		values = vals;
		boundary = b;
	}
	 
	public ConditionTemplate copy(int a)
	{
		int[] parts = new int[particles.length];
		for (int i=0; i<particles.length; i++)
		{
			parts[i] = particles[i] + a;
		}
		ConditionTemplate copy = 
				new ConditionTemplate(parameter, operation, parts, values, boundary);
		return copy;
	}
	
	public Condition createInstance(Vector particleGroups)
	{
		ParticleGroup[] partGroups = new ParticleGroup[particles.length];
		for (int i=0; i<particles.length; i++)
		{
			partGroups[i] = (ParticleGroup) particleGroups.elementAt(particles[i]);
		}
		Condition newCondition = 
			new Condition(parameter, operation, partGroups, values, boundary);
		return newCondition;
	}
}