import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import CoordinateLayout.*;

public class ForcesCheckBox extends JPanel
{
	public ForcesCheckBox(SimulationGenerator sg)
	{
		super();
		setBorder(new EtchedBorder());
		setLayout(new CoordinateLayout(new Dimension(8,6),8,8));
		add(new BrownianCheckBox(sg), new Coordinate(1,1,8,3));
		add(new ElectrostaticCheckBox(sg), new Coordinate(1,3,8,5));
	}
}
 
class BrownianCheckBox extends JCheckBox implements ItemListener
{
	SimulationGenerator simGen;
	
	public BrownianCheckBox(SimulationGenerator sg)
	{
		super("Brownian Motion");
		setSelected(true);
		addItemListener(this);
		simGen= sg;
	}
	
	public void itemStateChanged(ItemEvent ie)
	{
		SimulationGroup simGroup = simGen.getSimulationGroup();
		simGroup.setBrownianOn(isSelected());
	}
}

class ElectrostaticCheckBox extends JCheckBox implements ItemListener
{
	SimulationGenerator simGen;
	
	public ElectrostaticCheckBox(SimulationGenerator sg)
	{
		super("Electrostatic Forces");
		setSelected(true);
		addItemListener(this);
		simGen = sg;
	}
	
	public void itemStateChanged(ItemEvent ie)
	{
		SimulationGroup simGroup = simGen.getSimulationGroup();
		simGroup.setElectrostaticOn(isSelected());
	}
}