import java.util.Random;
import java.util.Date;

public class Medium
{
	float viscosity; // Units = Pascal seconds (Pa.s)
	float temperature; // Units = degrees kelvin (K)
	final float BoltzmannsConstant = 1.381f * (float) java.lang.Math.pow(10.0, -23.0);
	final float PI = (float) java.lang.Math.PI; 
	float radius;
	float brownianConstantTerm;

	public Medium()
	{
		viscosity = 0.001f; 			// water..
		temperature = 20.0f + 273.15f;  // .. at room temperature
		radius = 1f;
	}
	
	public float calculateBrownianTranslation(float radius, float timestep, Random r)
	{
		brownianConstantTerm = (float) java.lang.Math.sqrt(
			(float)((BoltzmannsConstant * temperature * timestep) 
						/ (3f * PI * viscosity * radius)));
		return (float) r.nextGaussian() * brownianConstantTerm; 
	}
	
	public void setTemperatureK(float t)
	{
		temperature = t;
	}
	
	public void setTemperatureC(float t)
	{
		temperature = t + 273.15f;
	}
	
	public float getTemperatureK()
	{
		return temperature;
	}
	
	public float getTemperatureC()
	{
		return temperature - 273.15f;
	}
	
	public void setViscosity(float v)
	{
		viscosity = v;
	}
	
	public float getViscosity()
	{
		return viscosity;
	}
}