public class ObjectState
{
	HingeObj[] hinges;
	ElectrostaticObj[] electros;
	ConnectionObj[] connects;
	CollisionObj[] collisions;
	StateChange[] stateChanges;

	public ObjectState(HingeObj[] h, ElectrostaticObj[] e, ConnectionObj[] con,
					   CollisionObj[] col, StateChange[] s)
	{
		hinges = h;
		electros = e;
		connects = con;
		collisions = col;
		stateChanges = s;
	}
	
	public void reset(int resetPos)
	{
		// Need to implement this when the particle groups are used
	}
	
	public void apply()
	{
		int i;
		for (i=0; i<hinges.length; i++)
		{
			hinges[i].apply();
		}
		for (i=0; i<electros.length; i++)
		{
			electros[i].apply(); 
		}
		for (i=0; i<connects.length; i++)
		{
			connects[i].apply();
		}
		
		for (i=0; i<collisions.length; i++)
		{
			collisions[i].apply();
		}
	}
	
	public int getState() 
	{
		int state;
		// Accept the first set of conditions to cause a state change
		for (int i=0; i<stateChanges.length; i++)
		{
			state = stateChanges[i].getState();
			if (state != -1)
			{ return state; }	
		}
		
		return -1;
	}
}