import java.util.*;

import javax.media.j3d.*;
import javax.vecmath.*;

import java.awt.*;

public class ParticleTemplate
{
	String name;
	Vector members;
	float[] colour;
	
	float radiusUnit, radiusVal;
	float radius;
	
	float chargeUnit, chargeVal;
	float charge;
	
	Vector states;

	public ParticleTemplate(Vector templateList)
	{
		name = "Untitled";
		radiusVal = 1f;
		radiusUnit = (float) Math.pow(10.0, -9.0);
		radius = radiusVal*radiusUnit;
		chargeVal = 0f;
		chargeUnit = 1f;
		members = new Vector();
		colour = new float[3];
		colour[0] = 1f; 
		colour[1] = 1f;
		colour[2] = 1f;
		templateList.addElement(this);
		
		states = new Vector();
		states.addElement("Start state");
	}
	
	public void setStates(Vector s)
	{
		states = s;
	}
	
	public Vector getStates()
	{
		return states;
	}
	
	public void setColour(float[] c)
	{
		if (c.length>2)
		{
			colour[0] = c[0];
			colour[1] = c[1];
			colour[2] = c[2];
		}
	}
	
	public void setMembers(Vector m)
	{
		members = m;
	}
	
	public Particle[] getMembers()
	{
		Particle[] part = new Particle[members.size()];
		members.copyInto(part);
		return part;
	}
	
	public void setCharge(float c)
	{
		charge = c;
	}
	
	public void setChargeVal(float r)
	{
		chargeVal = r;
		charge = chargeVal * chargeUnit;
	}
	
	public void setChargeUnit(float r)
	{
		chargeUnit = r;
		charge = chargeVal * chargeUnit;
	}
	
	public float getCharge()
	{
		return charge;
	}
	
	public float getChargeVal()
	{
		return chargeVal;
	}
	
	public float getChargeUnit()
	{
		return chargeUnit;
	}
	
	public void setColour(Color c)
	{
		float[] newCol = { ((float) c.getRed()) / 255f, 
						   ((float) c.getGreen()) / 255f, 
						   ((float) c.getBlue()) / 255f };
		colour = newCol;
	}
	
	public Color3f getColour3f()
	{
		return new Color3f(colour[0], colour[1], colour[2]);
	}
	
	public Color getColour()
	{
		return new Color(colour[0], colour[1], colour[2]);
	}
	
	public void setRadiusVal(float r)
	{
		radiusVal = r;
		radius = radiusVal * radiusUnit;
	}
	
	public void setRadiusUnit(float r)
	{
		radiusUnit = r;
		radius = radiusVal * radiusUnit;
	}
	
	public float getRadius()
	{
		return radius;
	}
	
	public float getRadiusVal()
	{
		return radiusVal;
	}
	
	public float getRadiusUnit()
	{
		return radiusUnit;
	}
	
	public void setName(String n)
	{
		name = n;
	}
	
	public String getName()
	{
		return name;
	}
	
	public Particle createInstance(float[] pos)
	{		
		// Create the instance particle
		Particle instP = new Particle(pos, this);
		instP.setStates(states);
		instP.setCurrentState(0);
		members.addElement(instP);
		
		return instP;
	}
}