import javax.swing.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import CoordinateLayout.*;

public class RandomPanel extends JPanel
{
	SimulationGenerator simGen;
	Random r;
	
	public RandomPanel(SimulationGenerator sg)
	{
		super();
		
		r = new Random(new Date().getTime());
		simGen = sg;
		
		setBorder(new EtchedBorder());
		setLayout(new CoordinateLayout(new Dimension(32,6),4,4));
		
		add(new JLabel("Random seed :"), new Coordinate(1,1,32,3));
		RandomTextField rtf = new RandomTextField(simGen, r);
		add(rtf, new Coordinate(1,3,20,5));
		add(new NewSeedButton(simGen, rtf), new Coordinate(20,3,31,5));
	}
}

class RandomTextField extends JTextField implements KeyListener
{
	SimulationGenerator simGen;
	Random rand;
	long seed;
	
	public RandomTextField(SimulationGenerator sg, Random r)
	{
		super(6);
		rand = r;
		seed = r.nextInt(100000000);
		setText(seed+"");
		simGen = sg;
		
		(simGen.getSimulationGroup()).setSeed(seed);
		setHorizontalAlignment(JTextField.RIGHT);
		addKeyListener(this);
	}
	
	public void keyPressed(KeyEvent ke)
	{}
	
	public void keyTyped(KeyEvent ke)
	{}
	
	public void keyReleased(KeyEvent ke)
	{
		try 
		{
			long seed = (long) (Long.parseLong(getText()));
			(simGen.getSimulationGroup()).setSeed(seed);
		}
		catch (NumberFormatException e)
		{}
	}
}

// Reset button
class NewSeedButton extends JButton implements ActionListener
{
	SimulationGenerator simGen;
	RandomTextField randTF;
	
	public NewSeedButton(SimulationGenerator sg, RandomTextField rtf)
	{
		super("New");
		addActionListener(this);
		simGen = sg;
		randTF = rtf;
	}
	
	public void actionPerformed(ActionEvent ae)
	{
		Random rand = new Random(new Date().getTime());
		long seed = rand.nextInt(100000000);
		(simGen.getSimulationGroup()).setSeed(seed);
		randTF.setText(""+seed);
	}
}
