import java.util.*;
 
public class SimObject
{
	ObjectState[] objectState;
	int currentState;
	Vector markedStates;
	ObjectTemplate template;

	public SimObject(ObjectState[] os, int cs, ObjectTemplate t)
	{
		objectState = os;
		currentState = cs;
		markedStates = new Vector();
		markedStates.addElement(new Integer(cs));
		template = t;
	}
	
	public String getName()
	{
		return template.getName();
	}
	
	public void apply()
	{
		if (currentState < objectState.length)
		{
			objectState[currentState].apply();
		}
	}
	
	public void checkStateChanged()
	{
		if (currentState < objectState.length)
		{
			int state = objectState[currentState].getState();
			
			if (state != -1)
			{
				currentState = state;
			}
		}
	}
	
	public void reset(int resetPos)
	{
		currentState = ((Integer) (markedStates.elementAt(resetPos))).intValue();
		for (int i=0; i<objectState.length; i++)
		{
			objectState[i].reset(resetPos);
		}
	}
}