public class SimulationObj
{
	SimObject[] objects;
	Particle[] particles;
	Medium medium;
	Boundary boundary;

	public SimulationObj(SimObject[] o, Particle[] p, Medium m, Boundary b)
	{
		objects = o;
		particles = p;
		medium = m;
		boundary = b;
	}
	
	public void apply()
	{		
		for (int i=0; i<objects.length; i++)
		{
			objects[i].apply();
		}
	}
	
	public void showParticles(SimulationGroup s)
	{
		for (int i=0; i<particles.length; i++)
		{
			particles[i].setBoundary(boundary);
			particles[i].setMedium(medium);
			particles[i].createJ3dObject();
			particles[i].addToSimulation(s);
		}
	} 
	
	public void checkStatesChanged()
	{
		for (int i=0; i<objects.length; i++)
		{
			objects[i].checkStateChanged();
		}
	}
	
	public void reset(int resetPos)
	{
		for (int i=0; i<objects.length; i++)
		{
			objects[i].reset(resetPos);
		} 
		for (int i=0; i<particles.length; i++)
		{
			particles[i].reset(resetPos);
		}
	}
}